/*-----------------------------------------
 * ebola_PASS
 *
 * Authentication systems for the Ebola Daemon
 *
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <crypt.h>

#define _XOPEN_SOURCE
#include <unistd.h>

#include "ebola_pass.h"

#define _PASS_CHECK_ON 1
#define _PASS_CHECK_OFF 0

char DEFAULT_passwdfile[]="./ebolapasswd";

int PASS_nocheck = _PASS_CHECK_ON;
char *PASS_passwdfile = DEFAULT_passwdfile;

int PASS_setpasswdfile( char *fname ){
   
   free(PASS_passwdfile);
   PASS_passwdfile = malloc(strlen(fname)*sizeof(char));
   strcpy(PASS_passwdfile,fname);
   
   return 0;
   }
   
   
int PASS_authenticate( char *uname, char *pass ){

   char line[1024];
   char *ccrypt;
   char salt[3];
   char *luname, *lpass;
   int result = _PASS_FAILED;
   FILE *f = fopen(PASS_passwdfile,"r");
   
   if (f){
      while (fgets(line,1023,f)){
         luname = strtok(line,":");
         if (strcmp(luname,uname) == 0){
            lpass = strtok(NULL,"\n\r");
            salt[0] = lpass[0];
            salt[1] = lpass[1];
            salt[2] = '\0';
            ccrypt = crypt(pass,salt);
            if (strncmp(ccrypt,lpass,11) == 0) result = _PASS_OK;
            break;
            }
         } /* while */
      fclose(f);
      } /* if f opened up */
   else {
        fprintf(stderr,"Error: Could not open password file %s\n",PASS_passwdfile);
        }
        
   return result;
   }
   

