#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define _XOPEN_SOURCE
#include <unistd.h>
#include <time.h>
#include <crypt.h>

char DEFAULT_passwdfile[]="./ebolapasswd";
char salt[]="XX";

int update_passwd( char *fname, char *user, char *crypt){
	FILE *f, *fo;
	char tmpfname[1024];
	char line[1024];
	char *inuser, *incrypt;
	int status = 0;
	
	snprintf(tmpfname,sizeof(tmpfname),"%s.tmp",fname);

	f = fopen(fname,"r");
	if (!f) { f = fopen(fname,"w"); fclose(f); f = fopen(fname,"r"); }
	if (!f) { fprintf(stderr,"Error: Cannot open %s for reading\n",fname); exit(1); }
	fo = fopen(tmpfname,"w");
	if (!fo) { fprintf(stderr,"Error: Cannot open %s for writing\n",tmpfname); exit(1); }

	while (fgets(line,1023,f)){
		inuser = strtok(line,":");
		if (inuser) {
			incrypt = strtok(NULL,"\n");
			if ( (status != 1) && (strncmp(user, inuser,strlen(inuser)) == 0)) {
				fprintf(stderr,"User exists, changing password\n");
				fprintf(fo,"%s:%s\n",user,crypt);
				status = 1;
				}
			else { fprintf(fo,"%s:%s\n",inuser,incrypt); }
			} /* if inuser */
		} /* while */
	if (status != 1) { fprintf(fo,"%s:%s\n",user,crypt); }

	fclose(f);
	fclose(fo);
	
	unlink(fname);
	rename(tmpfname, fname);

	return 0;
	}

int main( int argc, char **argv ){
   
   char *ccrypt = NULL;
   
   if (argc != 3) {
      fprintf(stderr,"%s Usage: %s <name> <password>\n\n",argv[0],argv[0]);
      exit(1);
      }

	srand(time(NULL));        
   salt[0] = (rand()%26) +64;
   salt[1] = (rand()%26) +64;
   
   ccrypt = crypt(argv[2],salt);
	update_passwd(DEFAULT_passwdfile, argv[1],ccrypt);
   
   return 0;
   }
